<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>pam_pkcs11: strings.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">pam_pkcs11
   &#160;<span id="projectnumber">0.6.11</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_fdedb0aba14d44ce9d99bc100e026e6a.html">common</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">strings.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
</div>
<p><a href="strings_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ae3fd0a2c68f60144e9b18b1ba45763e1"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a>&#160;&#160;&#160;extern</td></tr>
<tr class="memdesc:ae3fd0a2c68f60144e9b18b1ba45763e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">String management library.  <a href="#ae3fd0a2c68f60144e9b18b1ba45763e1">More...</a><br /></td></tr>
<tr class="separator:ae3fd0a2c68f60144e9b18b1ba45763e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a9631e70f79c6394494793f7c52c0b194"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#a9631e70f79c6394494793f7c52c0b194">is_empty_str</a> (const char *str)</td></tr>
<tr class="memdesc:a9631e70f79c6394494793f7c52c0b194"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check for a null or spaced string.  <a href="#a9631e70f79c6394494793f7c52c0b194">More...</a><br /></td></tr>
<tr class="separator:a9631e70f79c6394494793f7c52c0b194"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a371a8cb3e3e24b794a5a871fff24242e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#a371a8cb3e3e24b794a5a871fff24242e">clone_str</a> (const char *str)</td></tr>
<tr class="memdesc:a371a8cb3e3e24b794a5a871fff24242e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Duplicate a string.  <a href="#a371a8cb3e3e24b794a5a871fff24242e">More...</a><br /></td></tr>
<tr class="separator:a371a8cb3e3e24b794a5a871fff24242e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae73c7044be9e0f7e49ef2fecc0e1c143"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#ae73c7044be9e0f7e49ef2fecc0e1c143">toupper_str</a> (const char *str)</td></tr>
<tr class="memdesc:ae73c7044be9e0f7e49ef2fecc0e1c143"><td class="mdescLeft">&#160;</td><td class="mdescRight">Duplicate a string converting all chars to upper-case.  <a href="#ae73c7044be9e0f7e49ef2fecc0e1c143">More...</a><br /></td></tr>
<tr class="separator:ae73c7044be9e0f7e49ef2fecc0e1c143"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae51f5a5400748bc9b8b50f4d3480d588"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#ae51f5a5400748bc9b8b50f4d3480d588">tolower_str</a> (const char *str)</td></tr>
<tr class="memdesc:ae51f5a5400748bc9b8b50f4d3480d588"><td class="mdescLeft">&#160;</td><td class="mdescRight">Duplicate a string converting all chars to lower-case.  <a href="#ae51f5a5400748bc9b8b50f4d3480d588">More...</a><br /></td></tr>
<tr class="separator:ae51f5a5400748bc9b8b50f4d3480d588"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24e94eaf64482af3501c9f060b73d6f7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#a24e94eaf64482af3501c9f060b73d6f7">bin2hex</a> (const unsigned char *binstr, const int len)</td></tr>
<tr class="memdesc:a24e94eaf64482af3501c9f060b73d6f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a byte array into a colon-separated hexadecimal sequence.  <a href="#a24e94eaf64482af3501c9f060b73d6f7">More...</a><br /></td></tr>
<tr class="separator:a24e94eaf64482af3501c9f060b73d6f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3f4c76d88e1efa97cb1d057c2abdc80"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> unsigned char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#ae3f4c76d88e1efa97cb1d057c2abdc80">hex2bin</a> (const char *hexstr)</td></tr>
<tr class="memdesc:ae3f4c76d88e1efa97cb1d057c2abdc80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a colon-separated hexadecimal data into a byte array.  <a href="#ae3f4c76d88e1efa97cb1d057c2abdc80">More...</a><br /></td></tr>
<tr class="separator:ae3f4c76d88e1efa97cb1d057c2abdc80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a827a0b95a57290a2d2059d712cb168ee"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> unsigned char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#a827a0b95a57290a2d2059d712cb168ee">hex2bin_static</a> (const char *hexstr, unsigned char **res, int *size)</td></tr>
<tr class="memdesc:a827a0b95a57290a2d2059d712cb168ee"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert a colon-separated hexadecimal data into a byte array, store result into a previously allocated space.  <a href="#a827a0b95a57290a2d2059d712cb168ee">More...</a><br /></td></tr>
<tr class="separator:a827a0b95a57290a2d2059d712cb168ee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b7df0677fdea0c65c0faddfc40ff7ad"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#a9b7df0677fdea0c65c0faddfc40ff7ad">split</a> (const char *str, char sep, int nelems)</td></tr>
<tr class="memdesc:a9b7df0677fdea0c65c0faddfc40ff7ad"><td class="mdescLeft">&#160;</td><td class="mdescRight">Splits a string to an array of nelems by using sep as character separator.  <a href="#a9b7df0677fdea0c65c0faddfc40ff7ad">More...</a><br /></td></tr>
<tr class="separator:a9b7df0677fdea0c65c0faddfc40ff7ad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d3af2a4e490a5b521b7b2f22c6a4bbf"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#a5d3af2a4e490a5b521b7b2f22c6a4bbf">split_static</a> (const char *str, char sep, int nelems, char *dst)</td></tr>
<tr class="memdesc:a5d3af2a4e490a5b521b7b2f22c6a4bbf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Splits a string to an array of nelems by using sep as character separator, using dest as pre-allocated destination memory for the resulting array.  <a href="#a5d3af2a4e490a5b521b7b2f22c6a4bbf">More...</a><br /></td></tr>
<tr class="separator:a5d3af2a4e490a5b521b7b2f22c6a4bbf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac255ca3660b53737550b93d1020a1dd2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="strings_8h.html#ac255ca3660b53737550b93d1020a1dd2">trim</a> (const char *str)</td></tr>
<tr class="memdesc:ac255ca3660b53737550b93d1020a1dd2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Remove all extra spaces from a string.  <a href="#ac255ca3660b53737550b93d1020a1dd2">More...</a><br /></td></tr>
<tr class="separator:ac255ca3660b53737550b93d1020a1dd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ae3fd0a2c68f60144e9b18b1ba45763e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3fd0a2c68f60144e9b18b1ba45763e1">&#9670;&nbsp;</a></span>M_EXTERN</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define M_EXTERN&#160;&#160;&#160;extern</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>String management library. </p>

<p class="definition">Definition at line <a class="el" href="strings_8h_source.html#l00037">37</a> of file <a class="el" href="strings_8h_source.html">strings.h</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a24e94eaf64482af3501c9f060b73d6f7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a24e94eaf64482af3501c9f060b73d6f7">&#9670;&nbsp;</a></span>bin2hex()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char* bin2hex </td>
          <td>(</td>
          <td class="paramtype">const unsigned char *&#160;</td>
          <td class="paramname"><em>binstr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const int&#160;</td>
          <td class="paramname"><em>len</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert a byte array into a colon-separated hexadecimal sequence. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">binstr</td><td>ByteArray to be parsed </td></tr>
    <tr><td class="paramname">len</td><td>Number of bytes to be converted </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to result string or null if error in allocating memory </dd></dl>

</div>
</div>
<a id="a371a8cb3e3e24b794a5a871fff24242e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a371a8cb3e3e24b794a5a871fff24242e">&#9670;&nbsp;</a></span>clone_str()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char* clone_str </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Duplicate a string. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to be cloned </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to cloned string or null if error in allocating memory </dd></dl>

</div>
</div>
<a id="ae3f4c76d88e1efa97cb1d057c2abdc80"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3f4c76d88e1efa97cb1d057c2abdc80">&#9670;&nbsp;</a></span>hex2bin()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> unsigned char* hex2bin </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>hexstr</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert a colon-separated hexadecimal data into a byte array. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">hexstr</td><td>String to be parsed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to resulting byte array, or null if no memory available </dd></dl>

</div>
</div>
<a id="a827a0b95a57290a2d2059d712cb168ee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a827a0b95a57290a2d2059d712cb168ee">&#9670;&nbsp;</a></span>hex2bin_static()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> unsigned char* hex2bin_static </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>hexstr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned char **&#160;</td>
          <td class="paramname"><em>res</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>size</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert a colon-separated hexadecimal data into a byte array, store result into a previously allocated space. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">hexstr</td><td>String to be parsed </td></tr>
    <tr><td class="paramname">res</td><td>Pointer to pre-allocated user space </td></tr>
    <tr><td class="paramname">size</td><td>Pointer to store lenght of data parsed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to resulting byte array, or null on parse error </dd></dl>

</div>
</div>
<a id="a9631e70f79c6394494793f7c52c0b194"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9631e70f79c6394494793f7c52c0b194">&#9670;&nbsp;</a></span>is_empty_str()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> int is_empty_str </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check for a null or spaced string. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>Tested string </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>nonzero on null, empty or spaced string, else zero </dd></dl>

</div>
</div>
<a id="a9b7df0677fdea0c65c0faddfc40ff7ad"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9b7df0677fdea0c65c0faddfc40ff7ad">&#9670;&nbsp;</a></span>split()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char** split </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>sep</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>nelems</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Splits a string to an array of nelems by using sep as character separator. </p>
<p>To free() memory used by this call, call free(res[0]); free(res); </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to be parsed </td></tr>
    <tr><td class="paramname">sep</td><td>Character to be used as separator </td></tr>
    <tr><td class="paramname">nelems</td><td>Number of elements of resulting array </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>res: Pointer to resulting string array, or null if malloc() error </dd></dl>

</div>
</div>
<a id="a5d3af2a4e490a5b521b7b2f22c6a4bbf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5d3af2a4e490a5b521b7b2f22c6a4bbf">&#9670;&nbsp;</a></span>split_static()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char** split_static </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>sep</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>nelems</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>dst</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Splits a string to an array of nelems by using sep as character separator, using dest as pre-allocated destination memory for the resulting array. </p>
<p>To free() memory used by this call, just call free result pointer </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to be parsed </td></tr>
    <tr><td class="paramname">sep</td><td>Character to be used as separator </td></tr>
    <tr><td class="paramname">nelems</td><td>Number of elements of resulting array </td></tr>
    <tr><td class="paramname">dst</td><td>Char array to store temporary data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to resulting string array, or null if malloc() error </dd></dl>

</div>
</div>
<a id="ae51f5a5400748bc9b8b50f4d3480d588"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae51f5a5400748bc9b8b50f4d3480d588">&#9670;&nbsp;</a></span>tolower_str()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char* tolower_str </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Duplicate a string converting all chars to lower-case. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to be cloned &amp; lowercased </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to result string or null if error in allocating memory </dd></dl>

</div>
</div>
<a id="ae73c7044be9e0f7e49ef2fecc0e1c143"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae73c7044be9e0f7e49ef2fecc0e1c143">&#9670;&nbsp;</a></span>toupper_str()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char* toupper_str </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Duplicate a string converting all chars to upper-case. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to be cloned &amp; uppercassed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to result string or null if error in allocating memory </dd></dl>

</div>
</div>
<a id="ac255ca3660b53737550b93d1020a1dd2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac255ca3660b53737550b93d1020a1dd2">&#9670;&nbsp;</a></span>trim()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="strings_8h.html#ae3fd0a2c68f60144e9b18b1ba45763e1">M_EXTERN</a> char* trim </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Remove all extra spaces from a string. </p>
<p>a char is considered space if trues isspace()</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">str</td><td>String to be trimmed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Pointer to cloned string with all spaces trimmed or null if error in allocating memory </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed May 22 2019 12:09:35 for pam_pkcs11 by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
